#include "stdafx.h"

const long ERR_UNK = -1L;
const long NO_ERR = 0;

int rslt = 0;
char* chPkg;
normalPkg_t sndNmlPkg;
normalPkg_t rcvNmlPkg;
rspPtsPkg_t sndRspPkg;
rspPtsPkg_t rcvRspPkg;
bigBufferPkg_t bigBuff;

Client client("127.0.0.1");

void ZeroNmlPkgsNxtEvnt()
{
    memset(&sndNmlPkg, 0, NORMAL_PACKAGE_SIZE);     // null out normal package
    memset(&rcvNmlPkg, 0, NORMAL_PACKAGE_SIZE);     // null out normal package
    sndNmlPkg.basInf.eventId = NextEventId();
}

void ZeroRspPkgsNxtEvnt()
{
    memset(&sndRspPkg, 0, RESPONSE_POINTS_PACKAGE_SIZE);     // null out normal package
    memset(&rcvRspPkg, 0, RESPONSE_POINTS_PACKAGE_SIZE);     // null out normal package
    sndNmlPkg.basInf.eventId = NextEventId();
}

/*=======================================================================
-----------------------------------------------------------------------*/
unsigned long NextEventId()
{
    static unsigned long nxtEv = 0;
    if (nxtEv >= MAXUINT32) nxtEv =0;
    return nxtEv++;
};

 LB_API2_32_64_API LB_SetSysTimeOut(long newTimeout)
{
	return ERR_UNK;
} // SetSysTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_DriverVersion(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_DriverVersion;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SensorCnt(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SensorCnt;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SensorCnt

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_BlinkLED_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_BlinkLED_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_BlinkLED_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_BlinkLED_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_BlinkLED_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_BlinkLED_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_BlinkLED_Idx(long idx)												// JRS Added 
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_BlinkLED_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_BlinkLED_Addr


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SensorList(SensorDescrption* SD, long cnt)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SensorList;
    // set parms ........................................................
    sndNmlPkg.prms.longs[0] = cnt;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(SD,rcvNmlPkg.sd.sd,sizeof(SensorDescrption)*rcvNmlPkg.sd.cnt);
    return rcvNmlPkg.basInf.result;
} // LB_SensorList

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAddress_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAddress_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_GetAddress_SN


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAddress_Idx(long idx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAddress_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_GetAddress_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAddress_SN(char* SN, long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAddress_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    sndNmlPkg.prms.longs[0] = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAddress_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_AddressConflictExists(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_AddressConflictExists;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_AddressConflictExists

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_WillAddressConflict(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_WillAddressConflict;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_WillAddressConflict

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetSerNo_Addr(long addr, char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetSerNo_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(SN,rcvNmlPkg.prms.sns.snOne,SERIAL_NUMBER_LEN);
    return rcvNmlPkg.basInf.result;
} // LB_GetSerNo_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ChangeAddress(long currentAddr, long newAddr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ChangeAddress;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = currentAddr;
    sndNmlPkg.prms.longs[0] = newAddr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ChangeAddress

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetModelNumber_SN(char* SN, MODEL_NUMBER* modelNumber)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetModelNumber_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *modelNumber = (MODEL_NUMBER)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetModelNumber_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetModelNumber_Addr(long addr, MODEL_NUMBER* modelNumber)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetModelNumber_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *modelNumber = (MODEL_NUMBER)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetModelNumber_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_IsSensorConnected_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsSensorConnected_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_IsSensorConnected_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_IsSensorConnected_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsSensorConnected_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_IsSensorConnected_Addr;

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAutoPulseEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAutoPulseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAutoPulseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAutoPulseEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAutoPulseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} //LB_GetAutoPulseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetCWReference(long addr, double relRef, PWR_UNITS units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetCWReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = relRef;
    sndNmlPkg.prms.longs[0] = (long)units;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetCWReference

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCWReference(long addr, double* relRef, PWR_UNITS* units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCWReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *relRef = rcvNmlPkg.prms.dbls[0];
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} //LB_GetCWReference

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetCurrentState(long addr, struct SensorState state)
//{
//	return ERR_UNK;
//} //LB_SetCurrentState

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRegState(long addr, long regIdx, struct SensorState state)
//{
//	return ERR_UNK;
//}	// LB_SetRegState

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetCurrentState(long addr, struct SensorState* state)
//{
//	return ERR_UNK;
//}

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetRegState(long addr, long regIdx, struct SensorState* state)
//{
//	return ERR_UNK;
//}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetDoubleSidedLimit(long addr, double lowerVal, double upperVal, PWR_UNITS units, DS_RULE passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetDoubleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = lowerVal;
    sndNmlPkg.prms.dbls[1] = upperVal;
    sndNmlPkg.prms.longs[0] = (long)units;
    sndNmlPkg.prms.longs[1] = (long)passFail;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetDoubleSidedLimit(long addr, double* lowerVal, double* upperVal, PWR_UNITS* units, DS_RULE* passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetDoubleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *lowerVal = rcvNmlPkg.prms.dbls[0];
    *upperVal = rcvNmlPkg.prms.dbls[1];
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    *passFail = (DS_RULE)rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetDutyCycleEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetDutyCycleEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetDutyCycleEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetDutyCycleEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetDutyCyclePerCent(long addr, double val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetDutyCyclePerCent;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = val;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetDutyCyclePerCent(long addr, double* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetDutyCyclePerCent;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetFirmwareVersion(long  addr, char* buff, long  buffLen)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetFirmwareVersion;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = buffLen;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(buff,rcvNmlPkg.prms.sns.snOne,rcvNmlPkg.prms.longs[0]);
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetIndex_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetIndex_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetIndex_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetIndex_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetLimitEnabled(long addr, LIMIT_STYLE lmtStyle)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetLimitEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)lmtStyle;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;

}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetLimitEnabled(long addr, LIMIT_STYLE* lmtStyle)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetLimitEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *lmtStyle = (LIMIT_STYLE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetMeasurementPowerUnits(long addr,PWR_UNITS units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetMeasurementPowerUnits;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)units;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetMeasurementPowerUnits

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetMeasurementPowerUnits(long addr,PWR_UNITS* units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetMeasurementPowerUnits;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetMeasurementPowerUnits

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetModelNumber_Idx(long idx, MODEL_NUMBER* modelNumber)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetModelNumber_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *modelNumber = (MODEL_NUMBER)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
}	// LB_GetModelNumber_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetOffsetEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetOffsetEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}	// LB_SetOffsetEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetOffsetEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetOffsetEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetOffsetEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetPulseReference(long addr, 
										   double pulseRef, 
										   double peakRef, 
										   double averageRef, 
										   double dutyCycleRef, 
										   PWR_UNITS units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetPulseReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = pulseRef;
    sndNmlPkg.prms.dbls[1] = peakRef;
    sndNmlPkg.prms.dbls[2] = averageRef;
    sndNmlPkg.prms.dbls[3] = dutyCycleRef;
    sndNmlPkg.prms.longs[0] = (long)units;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}  // LB_SetPulseReference

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetPulseReference(long addr, 
										   double* pulseRef, 
										   double* peakRef, 
										   double* averageRef, 
										   double* dutyCycleRef, 
										   PWR_UNITS* units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetPulseReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*pulseRef = rcvNmlPkg.prms.dbls[0]; 
	*peakRef =  rcvNmlPkg.prms.dbls[1]; 
	*averageRef =  rcvNmlPkg.prms.dbls[2]; 
	*dutyCycleRef = rcvNmlPkg.prms.dbls[3]; 
	*units = (PWR_UNITS)rcvNmlPkg.prms.longs[0]; 
    return rcvNmlPkg.basInf.result;
} // LB_GetPulseReference

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetResponseEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetResponseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetResponseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetResponseEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetResponseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetResponseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetResponse(long addr, ResponsePoints* pts, long NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_SetResponse;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    sndRspPkg.rPts.cnt = NumPts;
    memcpy(sndRspPkg.rPts.pts, pts, sizeof(ResponsePoints) * NumPts);
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvRspPkg.basInf.result;
} // LB_SetResponse

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetResponse_Flat(long addr, double* freq, double* amplitude, long NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_SetResponse_Flat;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    sndRspPkg.rPts.cnt = NumPts;
    memcpy(sndRspPkg.rPtsFlat.frequency, freq, sizeof(double) * NumPts);
    memcpy(sndRspPkg.rPtsFlat.amplitude, amplitude, sizeof(double) * NumPts);
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvRspPkg.basInf.result;
} // LB_SetResponse_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetResponse(long addr, ResponsePoints* pts, long* NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_GetResponse;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    sndRspPkg.rPts.cnt = *NumPts;
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *NumPts = rcvRspPkg.rPts.cnt;
    memcpy(pts, &rcvRspPkg.rPts.pts, sizeof(ResponsePoints) * sndRspPkg.rPts.cnt);
    return rcvRspPkg.basInf.result;
} // LB_GetResponse


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetResponse_Flat(long addr, double* freq, double* amplitude, long* NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_GetResponse_Flat;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *NumPts = rcvRspPkg.rPts.cnt;
    memcpy(freq, &rcvRspPkg.rPtsFlat.frequency, sizeof(double) * sndRspPkg.rPtsFlat.cnt);
    memcpy(amplitude, &rcvRspPkg.rPtsFlat.amplitude, sizeof(double) * sndRspPkg.rPtsFlat.cnt);
    return rcvRspPkg.basInf.result;
} // LB_GetResponse_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetSerNo_Idx(long idx, char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetSerNo_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(SN,rcvNmlPkg.prms.sns.snOne,SERIAL_NUMBER_LEN);
    return rcvNmlPkg.basInf.result;
} // LB_GetSerNo_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetSerialNumber(long idx, long PW, char* SN)
//{
//	return ERR_UNK;
//} // LB_SetSerialNumber


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetSingleSidedLimit(long addr, double val, PWR_UNITS units, SS_RULE passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetSingleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = val;
    sndNmlPkg.prms.longs[0] = (long)units;
    sndNmlPkg.prms.longs[1] = (long)passFail;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetSingleSidedLimit

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetSingleSidedLimit(long addr, double* val, PWR_UNITS* units, SS_RULE* passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetSingleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.dbls[0];
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    *passFail = (SS_RULE)rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // LB_GetSingleSidedLimit

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_InitializeSensor_Idx(long idx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_InitializeSensor_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_InitializeSensor_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_MeasureCW_PF(long addr, 
								double* CW, 
								PASS_FAIL_RESULT* PF)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasureCW_PF;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *CW = rcvNmlPkg.prms.dbls[0];
    *PF = (PASS_FAIL_RESULT)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_MeasureCW_PF

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_MeasurePulse_PF(long addr, 
								double* pulse, 
								double* peak, 
								double* average, 
								double* dutyCycle, 
								PASS_FAIL_RESULT* PF)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasurePulse_PF;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*pulse = rcvNmlPkg.prms.dbls[0];
	*peak = rcvNmlPkg.prms.dbls[1];
	*average = rcvNmlPkg.prms.dbls[2];
	*dutyCycle = rcvNmlPkg.prms.dbls[3];
	*PF = (PASS_FAIL_RESULT)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_MeasurePulse_PF

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ReadStateFromINI(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ReadStateFromINI;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ReadStateFromINI

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_WriteStateToINI(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_WriteStateToINI;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ReadStateFromINI

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Recall(long addr, long regIdx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Recall;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = regIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_Recall

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Store(long addr, long regIdx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Store;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = regIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_Store

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetCurrentState(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetCurrentState;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetCurrentState

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetRegStates(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetRegStates;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetRegStates

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAddress_Idx(long idx, long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAddress_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    sndNmlPkg.prms.longs[0] = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAddress_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetOffset(long addr, double val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetOffset;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = val;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetOffset

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetOffset(long addr, double* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetOffset;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetOffset


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetCalDueDate(char* SN, long lngYear, long lngMonth, long lngDay)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetCalDueDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    sndNmlPkg.prms.longs[0] = lngYear;
    sndNmlPkg.prms.longs[1] = lngMonth;
    sndNmlPkg.prms.longs[2] = lngDay;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetCalDueDate

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCalDueDate(char* SN, long* year, long* month, long* day)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCalDueDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *year = rcvNmlPkg.prms.longs[0];
    *month = rcvNmlPkg.prms.longs[1];
    *day = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalDueDate

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetModelNumber(char* SN, long PW, MODEL_NUMBER modelNumber)
//{
//	return ERR_UNK;
//} // LB_SetModelNumber

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetCalOptExpDate(char* SN, long PW, long lngYear, long lngMonth, long lngDay)
//{
//	return ERR_UNK;
//} // LB_SetCalOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCalOptExpDate(char* SN, long* year, long* month, long* day)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCalOptExpDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *year = rcvNmlPkg.prms.longs[0];
    *month = rcvNmlPkg.prms.longs[1];
    *day = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetWtyOptExpDate(char* SN, long PW, long lngYear, long lngMonth, long lngDay)
//{
//	return ERR_UNK;
//} // LB_SetWtyOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetWtyOptExpDate(char* SN, long* year, long* month, long* day)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetWtyOptExpDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *year = rcvNmlPkg.prms.longs[0];
    *month = rcvNmlPkg.prms.longs[1];
    *day = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetConnectorOption(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetConnectorOption

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetConnectorOption(char* SN, long* val)
//{
//	return ERR_UNK;
//} // LB_GetConnectorOption

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetCalAndWtyOption(char* SN, long  PW, long  optVal)
//{
//	return ERR_UNK;
//} // LB_SetCalAndWtyOption

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCalAndWtyOption(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCalAndWtyOption;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalAndWtyOption

/*=======================================================================

-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRecorderOutOption(char* SN, long PW, long optVal)
//{
//
//	return ERR_UNK;
//} // LB_SetRecorderOutOption

/*=======================================================================

-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetRecorderOutOption(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetRecorderOutOption;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetRecorderOutOption

/*=======================================================================

-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetBestMatchOpt(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetBestMatchOpt

/*=======================================================================

-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetBestMatchOpt(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetBestMatchOpt;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetBestMatchOpt

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetTriggerOpt(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetTriggerOpt

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTriggerOpt(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTriggerOpt;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTriggerOpt

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetFilterOpt(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetFilterOpt

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetFilterOpt(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetFilterOpt;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetFilterOpt

/*=======================================================================

----------------------------------------------------------------------*/
LB_API2_32_64_API LB_InitializeSensor_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_InitializeSensor_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_InitializeSensor_SN

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_UninitializeSensor_SN(char* SN)
//{
//	return ERR_UNK;
//} // LB_UninitializeSensor_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_InitializeSensor_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_InitializeSensor_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_InitializeSensor_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetFrequency(long addr, double* value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetFrequency;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *value = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetFrequency

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetFrequency(long addr, double value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetFrequency;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = value;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetFrequency

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAverages(long addr, long* value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAverages;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *value = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetAverages

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAverages(long addr, long value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAverages;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = value;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAverages

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetPulseCriteria(long addr, double* value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetPulseCriteria;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *value = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetPulseCriteria

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetPulseCriteria(long addr, double value)			
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetPulseCriteria;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = value;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetPulseCriteria

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerInEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerInEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerInEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerInEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerInEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerInEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerInInverted(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerInInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerInInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerInInverted(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerInInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerInInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerInTimeOut(long addr, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerInTimeOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerInTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerInTimeOut(long addr, long val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerInTimeOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = val;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerInTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerOutEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerOutEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerOutEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerOutEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerOutInverted(long addr, FEATURE_STATE *st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerOutInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerOutInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerOutInverted(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerOutInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerOutInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAntiAliasingEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAntiAliasingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetAntiAliasingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAntiAliasingEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAntiAliasingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAntiAliasingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetRecorderOutEnabled(long addr, FEATURE_STATE* st)
//{
//	return ERR_UNK;
//} // LB_GetRecorderOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRecorderOutEnabled(long addr, FEATURE_STATE st)
//{
//	return ERR_UNK;
//} // LB_SetRecorderOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetRecorderOutSetup(long addr, double* val_0_V, double* val_1_V, PWR_UNITS* units)
//{
//	return ERR_UNK;
//} // LB_GetRecorderOutSetup

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRecorderOutSetup(long addr, double val_0_V, double val_1_V, PWR_UNITS units)
//{
//	return ERR_UNK;
//} // LB_SetRecorderOutSetup

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_MeasureCW(long addr, double* CW)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasureCW;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *CW = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_MeasureCW

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_MeasurePulse(long addr, double* pulse, double* peak, double* average, double* dutyCycle)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasurePulse;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pulse = rcvNmlPkg.prms.dbls[0];
    *peak = rcvNmlPkg.prms.dbls[1];
    *average = rcvNmlPkg.prms.dbls[2];
    *dutyCycle = rcvNmlPkg.prms.dbls[3];
    return rcvNmlPkg.basInf.result;
} // LB_MeasurePulse

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_ReInit_Addr(long addr)
//{
//	return ERR_UNK;
//}  // LB_ReInit_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_ReInit_Idx(long idx)
//{
//	return ERR_UNK;
//}  // LB_ReInit_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetExtendedAveragingEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetExtendedAveragingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetExtendedAveragingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetExtendedAveragingEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetExtendedAveragingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetExtendedAveragingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetExtendedAveraging(long addr, long* extAvg)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetExtendedAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *extAvg = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetExtendedAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetExtendedAveraging(long addr, long extAvg)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetExtendedAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = extAvg;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetExtendedAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetExtendedAveraging(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetExtendedAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetExtendedAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetMaxHoldEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetMaxHoldEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetMaxHoldEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetMaxHoldEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetMaxHoldEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetMaxHoldEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetMaxHold(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetMaxHold;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetMaxHold

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Get75OhmsEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Get75OhmsEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_ResetMaxHold

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Set75OhmsEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Set75OhmsEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetMaxHold

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_IsDeviceInUse_Idx(long idx)
//{
//	return ERR_UNK;
//} // LB_SensorCnt

//=============================================================================
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_IsDeviceInUse_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsDeviceInUse_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

//=============================================================================
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_IsDeviceInUse_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsDeviceInUse_SN;
    // set parms ........................................................
    memcpy( sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_SaveCurrStateTo(long addr, char* stateName)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_RestoreCurrStateFrom(long addr, char* stateName)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_GetNamedStateCount(long addr)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_GetNamedStateNames(long addr, char* names, long *cnt)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_DeleteNamedState(long addr, char* name)
//{
//	return ERR_UNK;
//}

//=============================================================================
// Name: LB_MeasureBurst_DBM
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_MeasureBurst_DBM(long addr, long delayUSEC, long measTimeUSEC, long trgInt, double* pk, double *avg, double *min)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasureBurst_DBM;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = delayUSEC;
    sndNmlPkg.prms.longs[1] = measTimeUSEC;
    sndNmlPkg.prms.longs[2] = trgInt;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pk = rcvNmlPkg.prms.dbls[0];
    *avg = rcvNmlPkg.prms.dbls[1];
    *min = rcvNmlPkg.prms.dbls[2];
    return rcvNmlPkg.basInf.result;
} // LB_MeasureBurst_DBM

LB_API2_32_64_API LB_CloseRestartSocketServerSocket(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_CloseRestartSocketServerSocket;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    return 1;
}
